﻿/*
 * Copyright 2011 hecke
 * 
 * This file is part of (G)VA18(B) multimeter protcol.
 * 
 * (G)VA18(B) multimeter protcol decoder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * (G)VA18(B) multimeter protcol decoder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with (G)VA18(B) multimeter protcol decoder. If not, see <http://www.gnu.org/licenses/>.
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GVA18BMeterReader
{
    class Dump2Display
    {
        static void Main(string[] args) {

            String port = args.Length > 0 ? args[0] : "com3";

            SerialCom ser_com = new SerialCom(port, 2400, System.IO.Ports.Parity.None, System.IO.Ports.StopBits.One, 8);

            if (!ser_com.isValid())
            {
                System.Console.WriteLine("Could not open serial port "+port+". Abort.");
                Environment.Exit(-1);
            }

            GVA18BProtocolDecoder decoder = new GVA18BProtocolDecoder();
            SerialCom.RecByteHandler rbh = decoder.parse;
            ser_com.AttachReceiver(ref   rbh);
                                    
            decoder.Attach(new GVA18BDisplayDump(ref decoder));

            ser_com.startReader();

            while (System.Console.Read() != 'q') {}

            ser_com.stopReader();

        }
    }
}


