﻿/*
 * Copyright 2011 hecke
 * 
 * This file is part of (G)VA18(B) multimeter protcol.
 * 
 * (G)VA18(B) multimeter protcol decoder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * (G)VA18(B) multimeter protcol decoder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with (G)VA18(B) multimeter protcol decoder. If not, see <http://www.gnu.org/licenses/>.
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GVA18BMeterReader
{
    class GVA18BDisplayDump : ObserverBase
    {
        private GVA18BProtocolDecoder proto_dec = null;

        public override void Update()
        {            
            if (proto_dec.hasValidData())
            {
                System.Console.WriteLine( (proto_dec.isAutoRange() ? "AUTO " : "     ") + 
                                          (proto_dec.isMinValue() ? "MIN " : "    ") +
                                          (proto_dec.isMaxValue() ? "MAX " : "    ") +
                                          (proto_dec.isRel() ? "REL " : "    ") +
                                          (proto_dec.isHold() ? "HOLD " : "     ")                                          
                                        );
                
                System.Console.WriteLine("mode: " + proto_dec.getMeterModeName() + " " + proto_dec.getMeterModePolarity());
                System.Console.WriteLine(proto_dec.ValueStr() + " " + proto_dec.getMeterModeUnit());
            }
            else
            {
                System.Console.WriteLine("***error reading data***");
            }
        }

        public GVA18BDisplayDump(ref GVA18BProtocolDecoder proto_dec)
        {
            this.proto_dec = proto_dec;
        }
    }
}
