﻿/*
 * Copyright 2011 hecke
 * 
 * This file is part of (G)VA18(B) multimeter protcol.
 * 
 * (G)VA18(B) multimeter protcol decoder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * (G)VA18(B) multimeter protcol decoder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with (G)VA18(B) multimeter protcol decoder. If not, see <http://www.gnu.org/licenses/>.
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GVA18BMeterReader
{
    class MeterModeDescriptor
    {
        public String Name
        {
            get;
            private set;
        }
        public String Unit
        {
            get;
            private set;
        }
        public String Polarity
        {
            get;
            private set;
        }

        byte mask_byte_0;
        byte mask_byte_9;
        byte mask_byte_10;
        byte mask_byte_11;
        byte mask_byte_12;
        byte mask_byte_13;

        int id;

        static int idc = 0;

        public MeterModeDescriptor(String name,
                                    String unit,
                                    String polarity,
                                    byte mask_byte_0,
                                    byte mask_byte_9,
                                    byte mask_byte_10,
                                    byte mask_byte_11,
                                    byte mask_byte_12,
                                    byte mask_byte_13)
        {
            this.mask_byte_0 = mask_byte_0;
            this.mask_byte_9 = mask_byte_9;
            this.mask_byte_10 = mask_byte_10;
            this.mask_byte_11 = mask_byte_11;
            this.mask_byte_12 = mask_byte_12;
            this.mask_byte_13 = mask_byte_13;
            this.id = ++idc;
            Name = name;
            Unit = unit;
            Polarity = polarity;
        }

        public bool test(ref byte[] data)
        {
            return (data[0] & 13) == mask_byte_0 &&
                        (data[9] & 15) == mask_byte_9 &&
                        (data[10] & 15) == mask_byte_10 &&
                        (data[11] & 12) == mask_byte_11 &&
                        (data[12] & 14) == mask_byte_12 &&
                        (data[13] & 15) == mask_byte_13;
        }

        public int modeId()
        {
            return id;
        }

    }
}
